////////////////////////////////////////////////////////////
//
//  define
#define MAX_FILE_NAME 260

////////////////////////////////////////////////////////////
//
//  Windows Callback Procdure
LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ShowInfoHeaderDlgProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK ShowPaletteDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);


////////////////////////////////////////////////////////////
//
//  Main Windows Message handlers
BOOL BmpView_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct);
void BmpView_OnDestroy(HWND hWnd);
void BmpView_OnCommand(HWND hWnd,int id,HWND hwndCtl,UINT codeNotify);
void BmpView_OnPaint(HWND hWnd);
void BmpView_OnInitMenu(HWND hWnd, HMENU hMenu);   // (HMENU) wParam

//void DrawBitmap(HDC hdc,int x,int y,HBITMAP hBit);
void ShowBitmapInfoHeader(HWND hWnd);
BOOL OpenBitmap(HWND hWnd);
BOOL SaveBitmap(HWND hWnd);
BOOL SaveAsBitmap(HWND hWnd);
BOOL Close(HWND hWnd);
void AntiClockWiseRotate(HWND hWnd);
void ClockWiseRotate(HWND hWnd);
void InvertColor(HWND hWnd);
void Mirror(HWND hWnd);
void MoveCenter(HWND hWnd);


////////////////////////////////////////////////////////////
//
//  Dialog Message handlers
BOOL DlgShowInfo_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam);
void DlgShowInfo_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify);
void DlgShowInfo_OnPaint(HWND hDlg);


BOOL DlgPalette_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam);
void DlgPalette_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify);
void DlgPalette_OnPaint(HWND hDlg);


LRESULT CALLBACK AboutDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);
BOOL DlgAbout_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam);
void DlgAbout_OnCommand(HWND hDlg,int id,HWND hwndCtl,UINT codeNotify);
void DlgAbout_OnPaint(HWND hDlg);






