//////////////////////////////////////////////////////////////////////////////////////////////
//  ƮóԼ
//  HongGetPixel  ȼ 
//  HongSetPixel  ȼ setϱ
//  HongRotate90R  Ʈ  90 ȸϱ
//  HongRotate90L  Ʈ  90 ȸϱ
//  HongInvertColor Ʈ Į  (not )
//  HongMirror  Ʈ ¿츦 Ī
//
//
//  Main include "MyBitmap.h"  ָ ȴ.
//
//

#include <windows.h>
#include "MyBitmap.h"

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongGetPixel : Ʈ dataκ ͸ ޾Ƽ x,y ǥ pixel  ´.
//  IN : 
//   pData Ʈ , int x,y Ϸ ϴ x,y ǥ
//   int width,height Ʈ  
//   unsigned bpp Ʈ ȼ Ʈ.
//
//  OUT :
//   BYTE* value  ȼ  ϱ char value[4] 
//
void HongGetPixel(IN BYTE *pData,IN int x,IN int y,IN int width ,IN int height,
				  OUT BYTE* value,IN unsigned short bpp)
{
	// Origin 0,0
	width=CalcWidth(width,bpp);
__asm
{
	mov		ax,bpp
	cmp		ax,1
	jz		bpp1
	cmp		ax,8
	jz		bpp8
	cmp		ax,24
	jz		bpp24
	jmp		end

bpp1:
	mov		eax,x
	mov		edx,0
	mov		cx,8
	div		cx
	mov		bx,7 
	sub		bx,dx  // 7-x/8
	push	ebx  // bits
	push	eax  // div result
	mov		ebx,y
	mov		eax,width
	mul		ebx     //  y*width
	pop		ebx      // div result
	add		eax,ebx    // x+y*width
	push	eax        // push offset
	mov		eax,[pData]
	pop		ebx        // offset pop
	add		eax,ebx    // pData+offset
	mov		bl,[eax]   // *(pData+offset)
	mov		bh,0
	pop		ecx         // bits
	bt		bx,cl      // bit==1 ?  bit==0 ?
	jc		set1
	mov		eax,[value]
	mov		ebx,0
	mov		[eax],bl
	jmp		end
set1:
	mov		eax,[value]
	mov		ebx,1
	mov		[eax],bl
	jmp		end
bpp8:
	mov		ebx,y
	mov		eax,width
	mul		ebx     //  y*width
	mov		ebx,x
	add		eax,ebx    // x+y*width
	push	eax        // push offset
	mov		eax,[pData]
	pop		ebx        // offset pop
	add		eax,ebx    // pData+offset
	mov		bl,[eax]   // *(pData+offset)
	mov		eax,[value]
	mov		[eax],bl
	jmp		end

bpp24:
	mov		eax,3
	mov		ebx,x
	mul		ebx     //  3*x
	push	eax
	mov		eax,width
	mov		ebx,y
	mul		ebx     //  y*width
	push	eax
	pop		ebx
	pop		eax
	add		eax,ebx    // x*3+y*width
	push	eax        // push offset
	mov		eax,[pData]
	pop		ebx        // offset pop
	add		eax,ebx    // pData+offset
	push	eax
	pop		ebx
	mov		eax,[value]
	mov		cl,[ebx]   // *(pData+offset)
	mov		[eax],cl   //  eax = value
	mov		cl,[ebx+1]   // *(pData+offset+1)
	mov		[eax+1],cl
	mov		cl,[ebx+2]   // *(pData+offset+1)
	mov		[eax+2],cl
	jmp		end

}
/*   Cҽ ڵ...
	if(bpp==1)
	{
		bit=7-x%8;
		mask=(BYTE)pow(2.0,bit);
		offset=(x/8)+y*width;
		value=*(pData+offset)&mask;
		value=value>>bit;
	}
	if(bpp==8)
	{
		offset=x+y*width;
		value=*(pData+offset);
	}

  	if(bpp==24)
	{
		offset=x*3+y*width;
		value[0]=*(pData+offset);
		value[1]=*(pData+offset+1);
		value[2]=*(pData+offset+2);
	}
	*/
end:
	return;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongSetPixel : Ʈ dataκ ͸ ޾Ƽ x,y ǥ pixel  setѴ.
//  IN : 
//   pData Ʈ , int x,y setϷ ϴ x,y ǥ
//   int width,height Ʈ  
//   BYTE* value setϱ  ȼ  ϱ char value[4] 
//   unsigned bpp Ʈ ȼ Ʈ.
//
void HongSetPixel(IN BYTE *pData,IN int x,IN int y,IN int width,IN int height ,
				  IN BYTE* value,IN unsigned short bpp)
{
	// Origin 0,0
	width=CalcWidth(width,bpp);
__asm
{
	mov		ax,bpp
	cmp		ax,1
	jz		bpp1
	cmp		ax,8
	jz		bpp8
	cmp		ax,24
	jz		bpp24
	jmp		end

bpp1:
	mov		eax,x
	mov		edx,0
	mov		cx,8
	div		cx
	mov		bx,7
	sub		bx,dx  // 7-x/8
	push	ebx  // bits
	push	eax  // div result
	mov		ebx,y
	mov		eax,width
	mul		ebx     //  y*width
	pop		ebx      // div result
	add		eax,ebx    // x+y*width
	push	eax
	mov		eax,[pData]
	pop		ebx
	add		eax,ebx    // pData+offset
	mov		bl,[eax]   // *(pData+offset)
	mov		bh,0
	pop		ecx         // bits
	push	eax
	mov		eax,[value]
	mov		dl,[eax]
	cmp		dl,1
	jz		bitset
	pop		eax
	btr		bx,cl
	mov		[eax],bl
	jmp		end
bitset:
	pop		eax
	bts		bx,cl
	mov		[eax],bl
	jmp		end
bpp8:
	mov		ebx,y
	mov		eax,width
	mul		ebx     //  y*width
	mov		ebx,x
	add		eax,ebx    // x+y*width
	push	eax        // push offset
	mov		eax,[pData]
	pop		ebx        // offset pop
	add		eax,ebx    // pData+offset
	xor		ebx,ebx
	push	eax
	mov		eax,[value]
	mov		bl,[eax]
	pop		eax
	mov		[eax],bl
	jmp		end

bpp24:
	mov		eax,3
	mov		ebx,x
	mul		ebx     //  3*x
	push	eax
	mov		eax,width
	mov		ebx,y
	mul		ebx     //  y*width
	push	eax
	pop		ebx
	pop		eax
	add		eax,ebx    // x*3+y*width
	push	eax        // push offset
	mov		eax,[pData]
	pop		ebx        // offset pop
	add		eax,ebx    // pData+offset
	push	eax
	pop		ebx
	mov		eax,[value]
	mov		cl,[eax]   // eax = value
	mov		[ebx],cl   // *(pData+offset)
	mov		cl,[eax+1]
	mov		[ebx+1],cl   // *(pData+offset+1)
	mov		cl,[eax+2]
	mov		[ebx+2],cl   // *(pData+offset+2)
	jmp		end
}
/*  Cҽ ڵ..
	if(bpp==1)
	{
		offset=(x/8)+y*width;
		bit=7-x%8;
		mask=1<<bit;
		if(value==1)
			*(pData+offset)=*(pData+offset)|mask;  // bit set 1
		else
			*(pData+offset)=*(pData+offset)&~mask;  // bit set 0
	}

	if(bpp==8)
	{
		offset=x+y*width;
		*(pData+offset)=value;
	}

	if(bpp==24)
	{
		offset=x*3+y*width;
		*(pData+offset)=value[0];
		*(pData+offset+1)=value[1];
		*(pData+offset+2)=value[2];
	}
*/
end:
	return;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongPixelInvert : value ޾Ƽ not  (HongInverColor ַ )
//  IN : 
//   BYTE* value ȼ Į (char value[4] ͸ ڷ ޴´.)
//   unsigned bpp Ʈ ȼ Ʈ.
//
//  OUT :
//
void HongPixelInvert(BYTE* value,unsigned short bpp)
{
__asm
{
	mov		ax,bpp
	cmp		ax,1
	jz		bpp1
	cmp		ax,8
	jz		bpp8
	cmp		ax,24
	jz		bpp24
	jmp		end

bpp1:
	mov		eax,[value]
	mov		bl,[eax]
	cmp		bl,1      // bit==1 ?  bit==0 ?
	jz		set0
	mov		ebx,1
	mov		[eax],bl
	jmp		end
set0:
	mov		ebx,0
	mov		[eax],bl
	jmp		end

bpp8:
	mov		eax,[value]
	mov		bl,[eax]
	not		bl
	mov		[eax],bl
	jmp		end

bpp24:
	mov		eax,[value]
	mov		bl,[eax]
	not		bl
	mov		[eax],bl
	mov		bl,[eax+1]
	not		bl
	mov		[eax+1],bl
	mov		bl,[eax+2]
	not		bl
	mov		[eax+2],bl
	jmp		end
}
end:
	return;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongRotate90R : Ʈ  ͸ ޾Ƽ Ʈ  90 ȸ
//  IN : 
//   BITMAPFILEHEADER* pBitmapFileHeader Ʈ .
//
//  OUT :
//
//  RETURN :
//   BITMAPFILEHEADER * ȸ Ų Ʈ  ͸ .
//
BITMAPFILEHEADER *HongRotate90R(BITMAPFILEHEADER* pBitmapFileHeader)
{
	int dx,dy,sx,sy;
	int width,height;
	int DataSize;
	BYTE value[4];
	unsigned short bpp;

	BITMAPFILEHEADER* pBitmapFileHeaderTemp;
	BITMAPINFOHEADER* pBitmapInfoHeaderTemp;
	BYTE* pBitmapDataTemp;

	BITMAPFILEHEADER* pOldBitmapFileHeader;
	BITMAPINFOHEADER* pBitmapInfoHeader;
	BYTE *pBitmapData;

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;

	bpp=pBitmapInfoHeader->biBitCount;
	width=pBitmapInfoHeader->biWidth;
	height=pBitmapInfoHeader->biHeight;

	DataSize=sizeof(BYTE)*width*CalcWidth(height,bpp);
	
	// ο  ޸𸮸 Ҵϰ   ī 0 ʱȭ Ѵ.
	pBitmapFileHeaderTemp = (BITMAPFILEHEADER *) malloc((pBitmapFileHeader->bfOffBits+DataSize));
	pBitmapDataTemp = (PBYTE)pBitmapFileHeaderTemp+pBitmapFileHeader->bfOffBits;
	memcpy(pBitmapFileHeaderTemp,pBitmapFileHeader,pBitmapFileHeader->bfOffBits);
	ZeroMemory(pBitmapDataTemp,DataSize);

	sx=width;
	for(dy=0;dy<width;dy++)
	{
		sy=0;
		sx--;
		for(dx=0;dx<height;dx++)
		{
			HongGetPixel(pBitmapData    ,sx,sy,width ,height,value,bpp);
			HongSetPixel(pBitmapDataTemp,dx,dy,height,width ,value,bpp);
			sy++;
		}
	}

	pOldBitmapFileHeader=pBitmapFileHeader;
	pBitmapFileHeader=pBitmapFileHeaderTemp;
	pBitmapInfoHeaderTemp=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));

	pBitmapInfoHeaderTemp->biWidth=height;
	pBitmapInfoHeaderTemp->biHeight=width;
	pBitmapInfoHeaderTemp->biSizeImage=DataSize;

	free(pOldBitmapFileHeader);
	
	return pBitmapFileHeader;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongRotate90L : Ʈ  ͸ ޾Ƽ Ʈ  90 ȸ
//  IN : 
//   BITMAPFILEHEADER* pBitmapFileHeader Ʈ .
//
//  OUT :
//
//  RETURN :
//   BITMAPFILEHEADER * ȸ Ų Ʈ  ͸ .
//
BITMAPFILEHEADER *HongRotate90L(BITMAPFILEHEADER* pBitmapFileHeader)
{
	int dx,dy,sx,sy;
	int width,height;
	int DataSize;
	BYTE value[4];
	unsigned short bpp;

	BITMAPFILEHEADER* pBitmapFileHeaderTemp;
	BITMAPINFOHEADER* pBitmapInfoHeaderTemp;
	BYTE* pBitmapDataTemp;

	BITMAPFILEHEADER* pOldBitmapFileHeader;
	BITMAPINFOHEADER* pBitmapInfoHeader;
	BYTE *pBitmapData;

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;

	bpp=pBitmapInfoHeader->biBitCount;
	width=pBitmapInfoHeader->biWidth;
	height=pBitmapInfoHeader->biHeight;

	DataSize=sizeof(BYTE)*width*CalcWidth(height,bpp);
	
	// ο  ޸𸮸 Ҵϰ   ī 0 ʱȭ Ѵ.
	pBitmapFileHeaderTemp = (BITMAPFILEHEADER *) malloc((pBitmapFileHeader->bfOffBits+DataSize));
	pBitmapDataTemp = (PBYTE)pBitmapFileHeaderTemp+pBitmapFileHeader->bfOffBits;
	memcpy(pBitmapFileHeaderTemp,pBitmapFileHeader,pBitmapFileHeader->bfOffBits);
	ZeroMemory(pBitmapDataTemp,DataSize);

	sx=0;
	for(dy=0;dy<width;dy++)
	{
		sy=height;
		for(dx=0;dx<height;dx++)
		{
			sy--;
			HongGetPixel(pBitmapData    ,sx,sy,width ,height,value,bpp);
			HongSetPixel(pBitmapDataTemp,dx,dy,height,width ,value,bpp);
		}
		sx++;
	}

	pOldBitmapFileHeader=pBitmapFileHeader;
	pBitmapFileHeader=pBitmapFileHeaderTemp;
	pBitmapInfoHeaderTemp=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));

	pBitmapInfoHeaderTemp->biWidth=height;
	pBitmapInfoHeaderTemp->biHeight=width;
	pBitmapInfoHeaderTemp->biSizeImage=DataSize;

	free(pOldBitmapFileHeader);
	
	return pBitmapFileHeader;
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongInvertColor : Ʈ  ͸ ޾Ƽ x,yǥ wx,hy ŭ Ʈ Ŵ
//  IN : 
//   BITMAPFILEHEADER* pBitmapFileHeader Ʈ .
//   int x,y ų ǥ int wx,hy ų  
//
//  OUT :
//   pBitmapFileHeader  Ÿ ٷ.
//
void HongInvertColor(BITMAPFILEHEADER* pBitmapFileHeader,int x,int y,int wx,int hy)
{
	int width,height;
	int i,j;
	unsigned short bpp;
	BYTE value[4];
	BITMAPINFOHEADER *pBitmapInfoHeader;
	BYTE *pBitmapData;

	width=x+wx;
	height=y+hy;

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;

	bpp=pBitmapInfoHeader->biBitCount;

	for(j=y;j<height;j++)
	{
		for(i=x;i<width;i++)
		{
			HongGetPixel(pBitmapData,i,j,width,height,value,bpp);
			HongPixelInvert(value,bpp);
			HongSetPixel(pBitmapData,i,j,width,height,value,bpp);
		}
	}

}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  HongMirror : Ʈ  ͸ ޾Ƽ x,yǥ wx,hy ŭ Ʈ ¿ ĪŴ
//  IN : 
//   BITMAPFILEHEADER* pBitmapFileHeader Ʈ .
//   int x,y ¿ Īų ǥ int wx,hy ¿ Īų  
//
//  OUT :
//   pBitmapFileHeader  Ÿ ٷ.
//
void HongMirror(BITMAPFILEHEADER* pBitmapFileHeader,int x,int y,int wx,int hy)
{
	int dx,dy,sx,sy;	
	int width,height;
	unsigned short bpp;
	BYTE value[4],valuetemp[4];
	BITMAPINFOHEADER *pBitmapInfoHeader;
	BYTE *pBitmapData;

	width=x+wx;
	height=y+hy;

	pBitmapInfoHeader=(BITMAPINFOHEADER*)((PBYTE)pBitmapFileHeader+sizeof(BITMAPFILEHEADER));
	pBitmapData=(PBYTE)pBitmapFileHeader+pBitmapFileHeader->bfOffBits;

	bpp=pBitmapInfoHeader->biBitCount;

	sy=y;
	for(dy=y;dy<height;dy++)
	{
		sx=width;
		for(dx=x;dx<width/2;dx++)
		{
			sx--;
			HongGetPixel(pBitmapData,sx,sy,width,height,value,bpp);
			valuetemp[0]=value[0];
			valuetemp[1]=value[1];
			valuetemp[2]=value[2];
			valuetemp[3]=value[3];
			HongGetPixel(pBitmapData,dx,dy,width,height,value,bpp);
			HongSetPixel(pBitmapData,sx,sy,width,height,value,bpp);
			HongSetPixel(pBitmapData,dx,dy,width,height,valuetemp,bpp);
		}
		sy++;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
//
//  CalcWidth : Ʈ  Է¹޾Ƽ DWORD   缳
//  IN : 
//   int width Ʈ 
//   unsigned short bpp Ʈ ȼ Ʈ
//
//  OUT :
//   int ewidth  DWORD   
//
int CalcWidth(int width,unsigned short bpp)
{
	int xbyte;
	int ewidth;

	if(bpp==1)
	{
		xbyte=(width/8)+((width%8)==0 ? 0:1);
		ewidth = (xbyte%4==0) ? xbyte:xbyte+(4-(xbyte%4));
	}
	else if(bpp==8)
		ewidth =(width%4)==0 ? width:width+(4-(width%4));
	else if(bpp=24)
	{
		xbyte=width*3;
		ewidth =(xbyte%4)==0 ? xbyte:xbyte+(4-(xbyte%4));
	}
	else
	{
		// etc bpp is not supported..!!!!!!
		return 0;
	}
	return ewidth;
}

